// =======================================================================
//  PAK 2.0 Professional Edition
//
//  My totally rewritten (first edition was dead in hdd crash) and now
//  is easy to use Westwood Studios PAK resources managing library.
//
//  Copyright (c) 1992 Westwood Studios, Inc.
//  Coded by pn0, 1994-1998.
//
//  Watcom C++ 10.0 16/32 any memory model
//
//  22 Oct 1998 - PAK 2.0 initial release
// =======================================================================


#include <stdio.h>	// FILE*, fopen(), fclose()
#include <string.h>	// strlen(), strcmp(), strcpy()
#include <malloc.h>	// malloc()
#include <io.h>		// filelength()


#ifndef _PAK2_H_INCLUDED

struct PAK
{
   FILE* file;
   unsigned long data_position;
   unsigned char* header_cache;
   unsigned long header_cache_index;
   unsigned long header_cache_data_position;
   char header_cache_name[13];
};


int pak_open(PAK& pak, char* name, char* mode);
int pak_cache(PAK& pak);
void pak_free_cache(PAK& pak);
int pak_close(PAK& pak);
int pak_find(PAK& pak, char* name, unsigned long& find_position);
int pak_seek(PAK& pak, char* name);
int pak_next(PAK& pak);
int pak_size_data(PAK& pak, char* name, unsigned long& data_size);
int pak_load_data(PAK& pak, char* name, unsigned char** data_pointer);
int pak_save_data_to_file(char* name, \
	unsigned char** data_pointer, unsigned long size);
void pak_free_data(unsigned char** data_pointer);


#include "pak2.inc"

#define _PAK2_H_INCLUDED
#endif

